#include <sragent.h>
#include <iostream>
#include "clistatus.h"
#include "helper.h"
#include "digitalOUT.h"
#include <stdio.h>
#include <stdlib.h>
#include <fstream>
#include <sys/wait.h>
#include <string.h>
#include <string>
#include <stdlib.h>
#include <srnetinterface.h>
#include <srnetbinhttp.h>
#include <unistd.h>
#include "configdb.h"
#include <srlogger.h>
#include <srdevicepush.h>

using namespace std;

Helper::Helper(SrAgent &a, SrNetInterface &nInterface, SrNetBinHttp &nBHttp, SrDevicePush &p): timer(10*1000, this), netInterface(nInterface), netBinHttp(nBHttp), pushDevice(p)
{
	int addResponse[] = {502, 503, 504, 505, 506, 507, 508, 509, 510, 511, 512, 513, 514, 515, 516, 517};
	
	for(size_t i = 0; i <= sizeof(addResponse)/sizeof(addResponse[0]); i++){
		a.addMsgHandler(addResponse[i], this);
	}
	 a.addTimer(timer);
         timer.start();
}

void Helper::operator()(SrTimer &timer, SrAgent &agent)
{	
	(void)timer;
        (void)agent;
        
	string alt  = new_getStatus("GNSS1_ALTITUDE");
  	string lat  = new_getStatus("GNSS1_LATITUDE");
      	string lng  = new_getStatus("GNSS1_LONGITUDE");
      	 if(alt.compare("n/a") != 0 && lat.compare("n/a") != 0 && lng.compare("n/a") != 0)
		agent.send("104," + agent.ID() + "," + alt + "," + lat + "," + lng);

        string timestamp  = new_getStatus("SYSTEM_TIME");
        if(alt.compare("n/a") != 0 && lat.compare("n/a") != 0 && lng.compare("n/a") != 0)
                agent.send("105," + agent.ID() + "," + alt + "," + lat + "," + lng + "," + timestamp);

        agent.send("106," + agent.ID() + "," + new_getStatus("TEMPERATURE"));

        string in1 = new_getStatus("IN1");
        string in2 = new_getStatus("IN2");
        string out1 = new_getStatus("OUT1");
        string out2 = new_getStatus("OUT2");
        if(getDigitalIO(in1) == 0)
		agent.send("110," + agent.ID() + "," + "0");

        if(getDigitalIO(in1) == 1)
                agent.send("110," + agent.ID() + "," + "1");

        if(getDigitalIO(in2) == 0)
                agent.send("111," + agent.ID() + "," + "0");

        if(getDigitalIO(in2) == 1)
                agent.send("111," + agent.ID() + "," + "1");
		
	if(getDigitalIO(out1) == 0)
                agent.send("112," + agent.ID() + "," + "0");

        if(getDigitalIO(out1) == 1)
                agent.send("112," + agent.ID() + "," + "1"); 

        if(getDigitalIO(out2) == 0)
                agent.send("113," + agent.ID() + "," + "0");

        if(getDigitalIO(out2) == 1)
                agent.send("113," + agent.ID() + "," + "1");
	
        agent.send("114," + agent.ID() + "," + new_getStatus("MOBILE1_CID") + "," + new_getStatus("MOBILE1_IMEI") + "," + new_getStatus("MOBILE1_ICCID") + "," + new_getStatus("MOBILE1_IMSI") + "," + new_getStatus("MOBILE1_LAC") + "," + new_getStatus("MOBILE1_MSISDN") + "," + new_getStatus("MOBILE1_BAND"));

        agent.send("115," + agent.ID() + "," + new_getStatus("MOBILE1_SIGNAL_RSSI"));
        agent.send("116," + agent.ID() + "," + new_getStatus("MOBILE1_SIGNAL"));
        agent.send("117," + agent.ID() + "," + new_getStatus("MOBILE1_SIGNAL_LEVEL"));

        if(new_getStatus("LAN1_STATE") == "up")
                agent.send("118," + agent.ID() + "," + new_getStatus("LAN1_MAC") + "," + new_getStatus("LAN1_ADDRESS") + "," + cli_get("NETWORK_LAN_0_NETMASK") + "," + "1"+ "," + cli_get("NETWORK_DHCP_0_START") + "," + cli_get("NETWORK_DHCP_0_END") + "," + cli_get("NETWORK_DHCP_0_DNS0") + "," + cli_get("NETWORK_DHCP_0_DNS1") + "," + "" + "," + cli_get("NETWORK_DHCP_0_MODE"));

	agent.send("119," + agent.ID() + "," + new_getStatus("WANLINK1_DATA_DOWNLOADED"));
        agent.send("120," + agent.ID() + "," + new_getStatus("WANLINK1_DATA_UPLOADED"));

	string wlanType = new_getStatus("WLAN1_OPER_TYPE");
	
	if(wlanType.compare("access-point") == 0){
        	agent.send("121," + agent.ID() + "," + new_getStatus("WLAN1_STATION_COUNT"));
		agent.send("124," + agent.ID()+ "," + new_getStatus("WLAN1_SSID") + "," + new_getStatus("WLAN1_MAC") + "," + new_getStatus("WLAN1_OPER_TYPE") + "," + new_getStatus("WLAN1_STATION_COUNT"));
	}
	
	agent.send("125," + agent.ID() + "," + new_getStatus("FEATURE_GPS")+ "," + new_getStatus("FEATURE_GSM")+ "," + new_getStatus("FEATURE_LTE")+ "," + new_getStatus("FEATURE_MOBILEIP")+ "," + new_getStatus("FEATURE_SERVER")+ "," + new_getStatus("FEATURE_UMTS")+ "," + new_getStatus("FEATURE_VIRT")+ "," + new_getStatus("FEATURE_VOICE")+ "," + new_getStatus("FEATURE_WLAN"));

	
}

void Helper::operator()(SrRecord &r, SrAgent &agent)
{
	
	
	ConfigDB cdb;
	cdb.load("/etc/c8yAgent.conf");
	const string netBoxIP = cdb.get("netBoxIP");
	if (netBoxIP.empty()) {
		srCritical("No IP.");
	}
	
	unsigned int response = strtoul(r.value(0).c_str(), NULL, 10);
	switch(response)
	{
		case 502:	
			{
				agent.send("108," + r.value(2) + ",EXECUTING");
                		for (size_t i = 0; i < r.size(); ++i)
                        		cerr << r.value(i) << " ";
                		cerr << endl;
                		agent.send("108," + r.value(2) + ",SUCCESSFUL");
                		sleep(2);
                		system("reboot");
			       	break;
			}
		case 503:       break;
		case 504:       break;
		case 505:	break;
		case 506:
			{
				agent.send("108," + r.value(2) + ",EXECUTING");
				
				char buffer [50];
                                int i = 0;
				sprintf (buffer, "cli set network.lan.0.address=%s network.lan.0.netmask=%s switch.port.3.status=%s", r.value(3).c_str(), r.value(4).c_str(), r.value(5).c_str());
                                system(buffer);
				sleep(5);

				FILE* pfilehandle;
				int rc = 0;
				string networkConfig = "ping -c 4 8.8.8.8";
				while(1){
					pfilehandle = popen(networkConfig.c_str(), "r");
					rc = pclose(pfilehandle);
					cout << "DEBUG: Ping returned" << rc << endl;
					sleep(1);
					if (rc/256 == 0)
						break;
					if(i == 0)
						cout << "LAN1 will be changed..." << endl;
					i = 1;
				}
				
				cout << "Change successful" << endl;
				agent.send("108," + r.value(2) + ",SUCCESSFUL");	

				break;
			}
		case 507:
			{
				agent.send("108," + r.value(2) + ",EXECUTING");
                                char buffer [50];
                                int i = 0;
                                sprintf (buffer, "cli set network.dhcp.0.start=%s network.dhcp.0.end=%s network.dhcp.0.dns0=%s network.dhcp.0.dns1=%s network.dhcp.0.mode=%s", r.value(3).c_str(), r.value(4).c_str(), r.value(5).c_str(), r.value(6).c_str(), r.value(8).c_str());
                                system(buffer);
                                sleep(1);

                                FILE* pfilehandle;
				int rc = 0;
                                string networkConfig = "ping -c 4 8.8.8.8";
                                while(1){
                                        pfilehandle = popen(networkConfig.c_str(), "r");
                                        rc = pclose(pfilehandle);
                                        cout << "DEBUG: Ping returned" << rc << endl;
                                        sleep(1);
                                        if (rc/256 == 0)
                                                break;
                                        if(i == 0)	
                                                cout << "DHCP will be changed..." << endl;
                                        i = 1;
                                }

                                agent.send("108," + r.value(2) + ",SUCCESSFUL");        
                                cout << "Change successful" << endl;
			       break;
			}
		case 508:      	setDigitalOut(r, agent); break;
		case 509:       break;
		case 510:
			{
				string commandString;
				string command = r.value(3);
				int ret = 0;
				if(command.compare("cli status") == 0 || command.compare("cli status wwan") == 0){
					commandString  = r.value(3) + " -s" + "> /tmp/shell.txt";
				}else{
					commandString  = r.value(3) + "> /tmp/shell.txt";
				}
				const char *commando= commandString.c_str();	
				FILE *stream = popen(commando, "w");
				ret = pclose(stream);
				ret = ret/256;
				if(ret == 0 )
				{
					ifstream file;
  					file.open("/tmp/shell.txt");
  					string gelesen;
					string alles;
 
  					while(getline(file,gelesen))
  					{
     						alles += gelesen + "\\n";		
  					}
					
					agent.send("127," + r.value(2) + ",SUCCESSFUL" + "," + r.value(3) + "," + alles);
					file.close();
				}else if(ret == 1){
	
					agent.send("127," + r.value(2) + ",FAILED" + "," + r.value(3) + "," + "No such file or directory");

				}else if(ret == 127){

					string notFound = r.value(3) + " not found";
					agent.send("127," + r.value(2) + ",FAILED" + "," + r.value(3) + "," + notFound );
			
				}
				break;
			}
		case 511:       break;
		case 512:
			{
				string logFileString;
				string logfile = r.value(3);
				string start = r.value(4);
				string stop = r.value(5);
				string lines = r.value(6);
				string filter = r.value(7);
				
				char *pchStart;
                                char *startTime = &start[0];
					
				char *pchStop;
                                char *stopTime = &stop[0];
				
                                int i=0;
				int k=0;
                                int timeDataStart[7];
                                int timeDataStop[7];
				
				string line;
				
				fstream f;
    				f.open("/tmp/temp.log", ios::out);
	
				if(logfile.compare("syslog") == 0)
				{
					pchStart = strtok (startTime,"-T:+");
					while (pchStart != NULL)
					{
						printf ("%s\n",pchStart);
						timeDataStart[i] = atoi(pchStart);
						pchStart = strtok (NULL, "-T:+");
						i++;
					}

					pchStop = strtok (stopTime,"-T:+");
					while (pchStop != NULL)
					{
						printf ("%s\n",pchStop);
						timeDataStop[k] = atoi(pchStop);
						pchStop = strtok (NULL, "-T:+");
						k++;
					}
					int m = timeDataStart[1];
					
					string scpCommand = "scp root@" + netBoxIP + ":/var/log/messages" + " /tmp/";		
					getFileOverSCP(scpCommand.c_str());										      
					sleep(2);		
					ifstream ifs("/tmp/messages");
					
					string start;
					string stop;
					
   					if (ifs.is_open())
    					{	
						while(m <= timeDataStop[1]){
							start = getString(timeDataStart[2]) + " "  + getZero(timeDataStart[3])+ ":"  + getZero(timeDataStart[4]);
							stop = getString(timeDataStop[2]) + " "  + getZero(timeDataStop[3])+ ":"  + getZero(timeDataStop[4]);
							int startLeange = start.length();
							int stopLeange = stop.length();
							ifs.clear();
							ifs.seekg(0, ios::beg);
            						while (getline(ifs, line)){
								if(line.compare(0 , 3, getMonth(m)) == 0){
									if(startLeange == 7 && stopLeange == 7){	
										if(line.compare(5 , 7, start) >= 0 && line.compare(5 , 7, stop) <= 0){	
											f << line << endl;
										}
									}else if (startLeange == 8 && stopLeange == 7){
										if(line.compare(4 , 8, start) >= 0 && line.compare(4 , 1, " ") != 0){
                                                                                        f << line << endl;
                                                                                }else if(line.compare(5 , 7, stop) <= 0 && line.compare(4 , 1, " ") == 0){
											f << line << endl;
										}

									}else if (startLeange == 7 && stopLeange == 8){
										if(line.compare(5 , 7, start) >= 0 && line.compare(4 , 1, " ") == 0){
                                                                                        f << line << endl;
                                                                                }
										else if (line.compare(4 , 8, stop) <= 0 && line.compare(4 , 1, " ") != 0){
                                                                                        f << line << endl;
										}

									}else {
										if(line.compare(4 , 8, start) >= 0 && line.compare(4 , 8, stop) <= 0){
                                                                                        f << line << endl;
                                                                                }

									}
								}
							}
							m++;
						}	
						ifs.clear();
						netBinHttp.postf("sys.log", "text/plain", "/tmp/temp.log");
						int counter = 0;
						string respBuffer = netBinHttp.response();
						char *syslogFile;
						char *responsFile = &respBuffer[0];
						syslogFile = strtok (responsFile,"{}\",");
                                		while (syslogFile != NULL)
                                		{
                                        		if(counter == 14)
								break;	
                                        		syslogFile = strtok (NULL, "{}\",");
							counter++;
                                		}
						netBinHttp.clear();

						agent.send("129," + r.value(2) + "," + r.value(3) + "," + r.value(4) + "," + r.value(5) + "," + r.value(6) + "," + r.value(7) + "," + syslogFile);
						f.close();
    					}

					
				}
				if(logfile.compare("scriptslog") == 0)
				{
					
					string scpCommand = "scp root@" + netBoxIP + ":/var/log/scripts.log" + " /tmp/";		
					getFileOverSCP(scpCommand.c_str());						
					ifstream ifs("/tmp/scripts.log");
					
					if(ifs.is_open())
					{
						while (getline(ifs, line)){
							f << line << endl;
						}
						if (!ifs.eof()) break; // Ensure end of read was EOF
                                                ifs.clear();
						netBinHttp.postf("scripts.log", "text/plain", "/tmp/temp.log");
                                                int counter = 0;
                                                string respBuffer = netBinHttp.response();
                                                char *scriptlogFile;
                                                char *responsFile = &respBuffer[0];
                                                scriptlogFile = strtok (responsFile,"{}\",");
                                                while (scriptlogFile != NULL)
                                                {
                                                        if(counter == 14)
                                                                break;
                                                        scriptlogFile = strtok (NULL, "{}\",");
                                                        counter++;
                                                }
                                                netBinHttp.clear();

                                                agent.send("129," + r.value(2) + "," + r.value(3) + "," + r.value(4) + "," + r.value(5) + "," + r.value(6) + "," + r.value(7) + "," + scriptlogFile);
                                                f.close();


					}
				}
				if(logfile.compare("errorlog") == 0)
				{
					
					string scpCommand = "scp root@" + netBoxIP + ":/var/log/lighttpd/error.log" + " /tmp/";		
					getFileOverSCP(scpCommand.c_str());						
					ifstream ifs("/tmp/error.log"); 

                                        if(ifs.is_open())
                                        {
					
                                                while (getline(ifs, line))
							f << line << endl;
						if (!ifs.eof()) break; // Ensure end of read was EOF	
						ifs.clear();	
					}
					netBinHttp.postf("error.log", "text/plain", "/tmp/temp.log");
					int counter = 0;
					string respBuffer = netBinHttp.response();
					char *errorlogFile;
					char *responsFile = &respBuffer[0];
					errorlogFile = strtok (responsFile,"{}\",");
					while (errorlogFile != NULL)
					{
						if(counter == 14)
							break;
						errorlogFile = strtok (NULL, "{}\",");
						counter++;
					}
					netBinHttp.clear();

					agent.send("129," + r.value(2) + "," + r.value(3) + "," + r.value(4) + "," + r.value(5) + "," + r.value(6) + "," + r.value(7) + "," + errorlogFile);
					f.close();

			

				}
			      	break;
			}
		case 513:       break;
		case 514:
			{
				
				fstream f;
                                f.open("/tmp/config.cfg", ios::out);
				f << r.value(3) << endl;
				
				string scpCommand = "scp /tmp/config.cfg root@" + netBoxIP + ":/tmp/";
				getFileOverSCP(scpCommand.c_str());		
				cout << "Config update..." << endl;
                                string scpCommandUpdateConf = "cli update config file:///tmp/config.cfg";
				getFileOverSCP(scpCommandUpdateConf.c_str());
				sleep(2);
				cout << "Finish" << endl;
				agent.send("108," + r.value(2) + "," + "SUCCESSFUL");       
				break;
			}
		case 515:       break;
		case 516:
			{	
				string configLine;
				string config;
				string dataTime = new_getStatus("SYSTEM_TIME");
					
				
				string scpCommand = "scp root@" + netBoxIP + ":/etc/config/user-config.cfg" + " /tmp/";		
                                getFileOverSCP(scpCommand.c_str());				
				sleep(1);	
				ifstream ifsConfig("/tmp/user-config.cfg");
				config = "#" + dataTime + "\\n";				

				if(ifsConfig.is_open()){
					while (getline(ifsConfig, configLine)){
						config += configLine + "\\n";
					}
				if (!ifsConfig.eof()) break; // Ensure end of read was EOF
                                ifsConfig.clear();

				agent.send("130," +  r.value(3) + "," + config);
				agent.send("108," + r.value(2) + "," + "SUCCESSFUL");
				}
			       	break;
			}
		case 517:       break;
	}
}
